import java.util.*;

public class Auto {
    private final String classe;
    private final String marca;
    private final String modello;
    private final int cilindrata;
    private final int potenza; 
    private final String alimentazione;
    private final int passeggeri;
    private final int bagagliaio;
    private final List<Agenzia> agenzie;

    public Auto() {
        this.classe = "";
        this.marca = "";
        this.modello = "";
        this.cilindrata = 0;
        this.potenza = 0;
        this.alimentazione = "";
        this.passeggeri = 0;
        this.bagagliaio = 0;
        this.agenzie = new ArrayList<>();
    }
    
    public Auto(String classe, String marca, String modello, int cilindrata, int potenza, String alimentazione, int passeggeri, int bagagliaio, List<Agenzia> agenzie) {
        this.classe = classe;
        this.marca = marca;
        this.modello = modello;
        this.cilindrata = cilindrata;
        this.potenza = potenza;
        this.alimentazione = alimentazione;
        this.passeggeri = passeggeri;
        this.bagagliaio = bagagliaio;
        this.agenzie = new ArrayList<Agenzia>(agenzie);
    }
    
    public Auto(Auto auto) {
        this.classe = auto.classe;
        this.marca = auto.marca;
        this.modello = auto.modello;
        this.cilindrata = auto.cilindrata;
        this.potenza = auto.potenza;
        this.alimentazione = auto.alimentazione;
        this.passeggeri = auto.passeggeri;
        this.bagagliaio = auto.bagagliaio;
        this.agenzie = new ArrayList<Agenzia>(auto.agenzie);
    }

    public String getClasse() {
        return classe;
    }

    public String getMarca() {
        return marca;
    }

    public String getModello() {
        return modello;
    }

    public int getCilindrata() {
        return cilindrata;
    }

    public int getPotenza() {
        return potenza;
    }

    public String getAlimentazione() {
        return alimentazione;
    }

    public int getPasseggeri() {
        return passeggeri;
    }

    public int getBagagliaio() {
        return bagagliaio;
    }
    
    public Agenzia[] getAgenzie() {
        Agenzia[] agenzie = new Agenzia[this.agenzie.size()];
        int n = 0;
        
        for (Agenzia agenzia : this.agenzie) {
            agenzie[n] = agenzia;
            n++;
        }
        return agenzie;
    }
}
