
package disneyland;
import java.io.*;
import java.sql.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.*;
import org.xml.sax.SAXException;

public class Import extends DefaultHandler {
    private String text;
    private String nome;
    private String citta;
    private String sigla;
    private int inserted;
    private Connection con;
    final String URL = "jdbc:mysql://localhost:3306";
    final String database = "Disneyland";
    final String user = "root";
    final String password = "";
    
    private void validate(String XMLdocument, String XSDschema) throws SAXException, IOException {
        // Lookup a factory for the W3C XML Schema language
        SchemaFactory factory = SchemaFactory.newInstance("http://www.w3.org/2001/XMLSchema");
        // Compile the schema (here the schema is loaded from a java.io.File, but you could use a java.net.URL instead)
        File schemaFile = new File(XSDschema);
        Schema schema = factory.newSchema(schemaFile);
        // Get a validator from the schema
        Validator validator = schema.newValidator();
        // Parse the document you want to check.
        Source source = new StreamSource(XMLdocument);
        // Check the document
        validator.validate(source);
    }
    
    public Import() throws SQLException {     
        // connessione al server DB
        con = DriverManager.getConnection(URL+"/"+database, user, password);
    }
    
     public void parseDocument(String filename) throws SAXException, ParserConfigurationException, IOException {
        
        validate(filename, "disneyland.xsd");
        // get a factory
	SAXParserFactory factory = SAXParserFactory.newInstance();
	// get a new instance of parser
        SAXParser parser = factory.newSAXParser();
        // parse the file and also register this class for call backs
        parser.parse(filename, this);
    }
    
    // metodi di gestione degli eventi SAX
    public void startDocument() {
        inserted = 0;
    }
    
    public void endDocument() {
    }
    
    public void startElement(String uriNamespace, String localNamespace, String qualifiedName, Attributes attributes) throws SAXException {
	text = "";
    }
    
    public void characters(char[] characters, int start, int length) throws SAXException {
        text = new String(characters, start, length);
    }
    
    public void endElement(String uriNamespace, String localNamespace, String qualifiedName) throws SAXException {
        Statement stat;
        ResultSet result;
        String query;
        String command;
        
        if (qualifiedName.equalsIgnoreCase("nome")) {
           nome = text;
	}
        else if (qualifiedName.equalsIgnoreCase("città")) {
           citta = text;
           try {
            stat = con.createStatement();
            query = "SELECT sigla FROM Citta WHERE denominazione = '" + citta + "';";
            result = stat.executeQuery(query);
            if (result.first())
                sigla =  result.getString("sigla");
            else
                sigla = "";
            stat.close();
           }
           catch (SQLException e) {
               sigla = "";
           }
	}
        else if (qualifiedName.equalsIgnoreCase("personaggio")) {
                System.out.println(nome + " " + citta);
                try {
                    stat = con.createStatement();
                    command = "INSERT INTO Personaggi(nome, citta) VALUES ('" + nome + "', '" + sigla + "');";
                    if (stat.executeUpdate(command) != 0)
                      inserted++;
                    stat.close();
               }
               catch (SQLException exception) {
               }
        }
        else if (qualifiedName.equalsIgnoreCase("elenco")) {
               System.out.println(inserted +" nuovi personaggi inseriti.");
	}
    }
    
    public void warning(SAXParseException exception) {
        System.out.println(exception.getMessage());
    }
    
    public void error(SAXParseException exception) {
        System.out.println(exception.getMessage());
    }
    
    public void fatalError(SAXParseException exception) {
        System.out.println(exception.getMessage());
    }
    
    public static void main(String[] args) {
        try {
            Import importer = new Import();
            importer.parseDocument("disneyland.xml");
        }
        catch (SAXException | ParserConfigurationException | IOException | SQLException exception) {
             System.out.println("Errore!");
        }
    }
}
