
import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class Parser extends DefaultHandler {

    private List libri;
    private String testo;
    private Libro libro;

    public Parser() {
        libri = new ArrayList();
    }

    public List getLibri() {
        return libri;
    }

    public void parseDocument(String filename)
            throws SAXException, ParserConfigurationException, IOException {
        // generazione di un’istanza del parser
        SAXParserFactory factory = SAXParserFactory.newInstance();
        SAXParser parser = factory.newSAXParser();
        // parsing del file e registrazione dello event handler
        parser. parse(filename, this);
    }
    
    /* metodi di gestione degli eventi */

    public void startDocument() {
        System.out.println("Inizio del parsing del documento...");
    }

    public void endDocument() {
        System.out.println("...fine del parsing del documento.");
    }

    public void startElement(String globalNamespace, String localNamespace,
            String elementName, Attributes attributes)
            throws SAXException {
        testo = "";
        if (elementName.equalsIgnoreCase("libro")) {
            // creazione di un nuovo oggetto di classe Libro
            libro = new Libro();
            libro.setGenere(attributes.getValue("genere"));
        }
    }

    public void characters(char[] characters, int start, int length)
            throws SAXException {
        testo = new String(characters, start, length);
    }

    public void endElement(String globalNamespace, String localNamespace,
            String elementName)
            throws SAXException {
        if (elementName.equalsIgnoreCase("libro")) {
            libri.add(libro);
        } else if (elementName.equalsIgnoreCase("autore")) {
            libro.setAutore(testo);
        } else if (elementName.equalsIgnoreCase("titolo")) {
            libro.setTitolo(testo);
        } else if (elementName.equalsIgnoreCase("prezzo")) {
            libro.setPrezzo(Float.parseFloat(testo));
        }
    }

    public void warning(SAXParseException exception) {
        System.out.println(exception.getMessage());
    }

    public void error(SAXParseException exception) {
        System.out.println(exception.getMessage());
    }

    public void fatalError(SAXParseException exception) {
        System.out.println(exception.getMessage());
    }

    public static void main(String[] args) {
        Parser sax = new Parser();
        try {
            sax.parseDocument(args[0]);
        } catch (SAXException | ParserConfigurationException | IOException exception) {
            System.out.println("Errore!");
        }
        // iterazione della lista e visualizzazione degli oggetti
        System.out.println("Numero di libri: " + sax.libri.size());
        Iterator iterator = sax.libri.iterator();
        while (iterator.hasNext()) {
            System.out.println(iterator.next().toString());
        }
    }
}
