
import java.math.BigDecimal;
import javax.xml.bind.annotation.*;

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "tipo_libro", propOrder = {"autore", "titolo", "prezzo" })
@XmlSeeAlso({TipoLibroGenere.class})
public class TipoLibro {
    @XmlElement(required = true)
    protected String autore;
    @XmlElement(required = true)
    protected String titolo;
    @XmlElement(required = true)
    protected BigDecimal prezzo;

    public TipoLibro() {
    }
    
    public TipoLibro(String autore, String titolo, BigDecimal prezzo) {
        this.autore = autore;
        this.titolo = titolo;
        this.prezzo = prezzo;
    }
    
    public String getAutore() {
        return autore;
    }

    public void setAutore(String value) {
        this.autore = value;
    }
    
    public String getTitolo() {
        return titolo;
    }

    public void setTitolo(String value) {
        this.titolo = value;
    }

    public BigDecimal getPrezzo() {
        return prezzo;
    }
    
    public void setPrezzo(BigDecimal value) {
        this.prezzo = value;
    }

    public String toString() {
        return autore + ", \"" + titolo + "\" (" + prezzo + "€)";
    }
}
